VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cRequestDataBuilder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Url (r/w) - url     
Public Url
' ContentType (r/w) -    
'application/x-www-form-urlencoded -     
'multipart/form-data -    
'text/plain -    
'(!)      charset / boundary  .
Public ContentType
' Method (r/w) -    (GET / POST)
Public Method
' HideFilePath (r/w) -        
Public HideFilePath
' POST 
Public Body

Private oHtmlDoc, oScript, aItems

'  
Private Sub Class_Initialize()
    '  htmlfile        encodeURIComponent
    Set oHtmlDoc = CreateObject("htmlfile")
    Set oScript = oHtmlDoc.Script
    oScript.execScript ("eval()")
    ' URL  
    Url = "about:blank"
    '  
    aItems = Array()
    '    
    Method = "GET"
    '   
    ContentType = "application/x-www-form-urlencoded"
    '      
    HideFilePath = True
End Sub

'  
'Name -  
'Value -  
Public Sub AddField(Name, value)
    AddItem Array(0, Name, value)
End Sub

'  
'Name -  
'FilePath -   
'ContentType -   (image/png | image/gif | application/binary  ..)
Public Sub AddFile(Name, FilePath, ContentType)
    AddItem Array(1, Name, FilePath, ContentType)
End Sub

'     
'aProperties -  
Private Sub AddItem(aProperties)
    Dim lCount
    lCount = UBound(aItems) + 1
    ReDim Preserve aItems(lCount)
    aItems(lCount) = aProperties
End Sub

'       
Private Function BuildQueryString()
    Dim aItem, value
    With oScript
        '    aItems
        For Each aItem In aItems
            '  
            value = aItem(2)
            '    1,   .   ,   
            If aItem(0) = 1 And HideFilePath Then value = GetFileName(value)
            '  
            BuildQueryString = BuildQueryString & "&" & .encodeURIComponent(aItem(1)) & "=" & .encodeURIComponent(value)
        Next
    End With
    '  "&"   
    BuildQueryString = Mid(BuildQueryString, 2)
End Function

'     
Private Function BuildHeader(Items)
    Dim sKey, sValue
    For Each sKey In Items.Keys
        sValue = Items(sKey)
        If sValue <> "" Then
            BuildHeader = BuildHeader & "; " & sKey & "=" & Items(sKey)
        Else
            BuildHeader = BuildHeader & "; " & sKey
        End If
    Next
    BuildHeader = Mid(BuildHeader, 3)
End Function

'     
Private Function ParseHeader(Header)
    Dim oDict: Set oDict = CreateObject("Scripting.Dictionary")
    Dim aGroups: aGroups = Split(Header, ";")
    Dim Group, sValue
    oDict.CompareMode = vbTextCompare
    For Each Group In aGroups
        Group = Split(Group, "=", 2)
        If UBound(Group) = 1 Then sValue = Group(1)
        oDict(Trim(Group(0))) = Trim(sValue)
    Next
    Set ParseHeader = oDict
End Function

'  ,     
Public Sub Build()
    '   
    Const DefaultBoundary = "--"
    
    Body = Empty
    
    Dim sValue, aItem
    '    - GET
    Select Case UCase(Method)
    Case "GET"
        '     GET,      
        If UBound(aItems) > 0 Then
            lPos = InStr(1, Url, "?")
            If lPos > 0 Then Url = Left(Url, lPos - 1)
            Url = Url & "?" & BuildQueryString
        End If
    Case "POST"
        Dim aKeys, oParams
        ' ContentType
        Set oParams = ParseHeader(ContentType)
        '   
        aKeys = oParams.Keys
        ',    .     
        Select Case LCase(aKeys(0))
        Case "application/x-www-form-urlencoded"
            Body = BuildQueryString()
        Case "multipart/form-data"
            '   ADODB.Stream
            Const adTypeBinary = 1
            Const adTypeText = 2
            Dim oStream, oFileStream, sContentType
            ' -     boundary
            If Not oParams.Exists("boundary") Then oParams("boundary") = GenerateBoundary
            ' Content-Type   boundary
            ContentType = BuildHeader(oParams)
            ' Stream     
            Set oStream = CreateObject("ADODB.Stream")
            ' Stream   
            Set oFileStream = CreateObject("ADODB.Stream")
            '      
            oFileStream.Type = adTypeBinary
            '      
            With oStream
                .Type = adTypeText
                .Charset = "Windows-1251"
                .Open
                '  
                For Each aItem In aItems
                    '  
                    If aItem(0) = 1 Then
                        '    ,    
                        'if .Type <> adTypeText Then ChangeStreamType(adTypeText)
                        ' ContentType 
                        sContentType = aItem(3)
                        ' ContentType  ,    
                        If Len(sContentType) <= 0 Then sContentType = "application/octet-stream"
                        '   -   
                        sValue = aItem(2)
                        '   ,    
                        If HideFilePath Then sValue = GetFileName(sValue)
                        '   
                        .WriteText DefaultBoundary & oParams("boundary") & vbCrLf & _
                                    "Content-Disposition: form-data; name=""" & aItem(1) & """; filename=""" & sValue & """" & vbCrLf & _
                                    "Content-Type: " & sContentType & vbCrLf & vbCrLf

                        '     
                        ChangeStreamType oStream, adTypeBinary
                        '  
                        With oFileStream
                            .Open
                            .LoadFromFile aItem(2)
                            '   
                            oStream.Write oFileStream.Read
                            .Close
                        End With
                        '    
                        ChangeStreamType oStream, adTypeText
                        '  
                        .WriteText vbCrLf
                    Else
                        'if .Type <> adTypeText Then ChangeStreamType(adTypeText)
                        .WriteText DefaultBoundary & oParams("boundary") & vbCrLf & _
                                    "Content-Disposition: form-data; name=""" & aItem(1) & """" & vbCrLf & vbCrLf & aItem(2) & vbCrLf
                    End If
                Next
                '   "--BOUNDARY_VALUE--"
                .WriteText DefaultBoundary & oParams("boundary") & DefaultBoundary
                '           
                .Position = 0
                .Type = adTypeBinary
                ' Body  
                Body = .Read
                .Close
            End With
        Case "text/plain"
            Dim sData
            For Each aItem In aItems
                sValue = aItem(2)
                If aItem(0) = 1 And HideFilePath Then sValue = GetFileName(sValue)
                sData = sData & vbCrLf & aItem(1) & "=" & sValue
            Next
            Body = Replace(Mid(sData, 2), " ", "+")
        Case Else
            Err.Raise vbObjectError + 2, TypeName(Me), "Unknown enctype"
        End Select
    Case Else
        Err.Raise vbObjectError + 3, TypeName(Me), "Unknown request method"
    End Select
End Sub

'     (  /  )
Private Sub ChangeStreamType(oStream, StreamType)
    Dim lPos
    With oStream
        '   
        lPos = .Position
        '      
        .Position = 0
        .Type = StreamType
        '   
        .Position = lPos
    End With
End Sub

'  boundary
Private Function GenerateBoundary()
    Const Chars = "abcdefghijklmopqrstuvwxyz0123456789"
    Dim i, r, c
    Randomize
    GenerateBoundary = String("27", "-")
    For i = 1 To 13
        r = Int(Len(Chars) * Rnd + 1)
        c = Mid(Chars, r, 1)
        If r Mod 2 Then c = UCase(c)
        GenerateBoundary = GenerateBoundary & c
    Next
End Function

'     
'(    RegExp,     )
Private Function GetFileName(FilePath)
    Dim p1, p2
    p1 = InStrRev(FilePath, "\")
    p2 = InStrRev(FilePath, "/")
    If p2 > p1 Then p1 = p2
    GetFileName = Mid(FilePath, p1 + 1)
End Function
